---
title:       Documentation
description: The documentation on the Dxcker project
---

<div class="alert alert-warning" role="alert">

	<b>These guidelines are under active development</b><br />
	<p>
		These guidelines may be updated as required to cover new conventions. They may be added to or changed without notice.
	</p>

</div>

<hr />

<h2>README's</h2>

<p>We are currently working on a method of importing all README's in the project folders to this page.</p>

<hr />

Dxcker is a repository of standardized Docker images that can be easily dropped into any environment. The core ideology is to keep Dockerfiles clean, simple and based of a central location. 

<h2>Core Tenets</h2>

The core of this projects ideology can be summed up to:

<ol>
	<li>All containers are based on the dxcker base image (based on latest stable Alpine).</li>
	<li>All containers use ENTRYPOINT and CMD; absolutely no custom start scripts.</li>
	<li>All containers must use the volume conventions.</li>
	<li>All containers must run using the `app` system user, with UID and GUID of 1000.</li>
	<li>All containers must log to stdout.</li>
</ol>

The primary idea of this project is to standardize the inputs and outputs of a container. This is largely controlled by the volume conventions; the inputs can be considered the configuration, and the output can be considered the storage volume or the logging.

A container may break these conventions only if the software forces it to and a workaround does not exist. When this happens, it must be **clearly** documented in a standardized manner. No standard exists for this, as it has not happened.

<h2>Conventions</h2>

<ol>
	<li>
		Storage
		<ol>
			<li>/config for all configuration</li>
			<li>/data for all stored data</li>
			<li>/startup for all required startup items (eg/ SQL for the MariaDB image to run on startup)</li>
			<li>Configuration files will not be auto-populated, as its a limitation of our core tenets.</li>
		</ol>
	</li>
</ol>
